/*
 * @copyright		© Copyright 2006-2011, epages GmbH, All Rights Reserved.
 *
 * @module			ep.ui.colortool
 *
 * @revision		$Revision: 1.5 $
 */

define("ep/ui/colortool", ["jquery", "ep/ajax", "ep/ui/colorpicker", "ep/ui/input"], function($, ep){

	$.widget( "ui.uiColortool", $.ui.uiColorpicker, {

		options: {
			color: ""
		},

		_create: function(){
			var self = this,
				elem = self.element,
				o = self.options;

			self.wrapper = $('<span/>').addClass("ep-uiInput-custom");

			elem.attr("readonly", true)
				.val( o.color = o.color || elem.val() || "#fff" )
				.after(self.wrapper)
				.on("keydown", function (event) {
					if(event.keyCode === $.ui.keyCode.SPACE){
						self.open();
					}
				});

			//
			if( epages.vars.StyleUserDefinedColors ){
				var extended = {
						baseColors:	$("#LayoutBackgroundColor").val(),
						userColors: {},
						userColorsSave: function( data ){
							var ajaxData = [
									{name: "ViewAction",	value: "JSONViewResponse"},
									{name: "ChangeAction",	value: "SaveGUIDList"},
									{name: "ObjectID",		value: ep.config.siteId}
								];

							$.each( data, function(){
								ajaxData.push(
									{name: "GUID",			value: self.styleId},
									{name: "Name",			value: this.name},
									{name: "Value",			value: this.value}
								);
							});

							ep.ajax({
								type:		"post",
								dataType:	"json",
								data:		ajaxData
							});
						}
					};

				$.each( epages.vars.StyleUserDefinedColors.split("|"), function( i, val ){
					extended.userColors[ "UserDefinedColor"+i ] = val;
				});

				o.extended = extended;
			}

			self._superApply(arguments);

			elem.addClass("ep-uiColortool")
				.on("colorApply.uiColortool", $.proxy(self, "_onApply"));
		},

		_init: function(){
			this._superApply(arguments);
			this._setColorTool( this.options.color );
		},

		_setColorTool: function( color ){
			var isTransparent = color == "transparent";

			this.wrapper
				.css("background-color", isTransparent ? "#fff" : color)
				.toggleClass("ep-uiColortool-transparent",isTransparent);

			this.element
				.val(color);
		},

		_onApply: function( event, color ){
			this._setColorTool(color);

			$( this.elem.trigger({type:"change",dojoconnect:true})[0].form ).trigger("change");
		},

		destroy: function(){
			this.elem
				.off(".uiColortool");

			this._superApply(arguments);
		}

	});

	return ep;

});