define("de_epages/amazonpayments/checkoutconfirmation", [
  "jquery"
], function ($) {
  var basketData = $("#addressBookWidgetDiv").data(),
    BasketId = basketData.basketid,
    ReferenceId = basketData.refid,
    MerchantId = basketData.merchantid;

  function handleError(errorCode, errorType) {
    ep("body").busy("show");
    window.location.href = "?ViewAction=TriggerAmazonPaymentsError&ObjectID=" + BasketId + "&" + errorType + "=" + errorCode;
  };

  new OffAmazonPayments.Widgets.AddressBook({
    sellerId: MerchantId,
    amazonOrderReferenceId: ReferenceId,
    displayMode: "Read",
    design: { size : { width:"290px", height:"185px" } },
    onError: function(error) { handleError(error.getErrorCode(), "AddressError"); }
  }).bind("addressBookWidgetDiv");

  new OffAmazonPayments.Widgets.Wallet({
    sellerId: MerchantId,
    amazonOrderReferenceId: ReferenceId,
    displayMode: "Read",
    design: { size : { width:"290px", height:"185px" } },
    onError: function(error) { handleError(error.getErrorCode(), "WalletError"); }
  }).bind("walletWidgetDiv");
});
